searchData={"items":[{"type":"module","title":"RegexFormatter","doc":"RegexFormatter\n--------------\nDon't fear the regex. Malleable 'mix format' via powerful code-search/replace.\n\nUsage\n-----\nConfigure and run Regex Formatter in three steps:\n\n1. Add `RegexFormatter` to `plugins` list in `.formatter.exs`.\n2. Add `regex_formatter` config to `.formatter.exs` following examples below.\n3. Run `mix format` — Regex Formatter rules will run after normal format operations.\n\n```elixir\n[                                        #  ┌── [1] Add RegexFormatter to plugins.\n  ...                                    #  │\n  plugins: [Phoenix.LiveView.HTMLFormatter, RegexFormatter],\n  regex_formatter: [  #  <───── [2] Add configuration for RegexFormatter.\n    [\n      extensions: [\".ex\", \".exs\"],  #  <─── [3] Configure file types to replace on.\n      replacements: [\n        {\n          ~r/~u[\"]\\s+/s,  #  <───── [4] Define search pattern.\n          \"~u\\\"\"          #  <───── [5] Define replacement pattern.\n        },\n        {\n          ~r/(~u[\"][^\"]+[^\"\\s])  +([^\"\\s])/s,\n          ~S'\\1 \\2',   #  <─────── [6] Replace with matched groups.\n          repeat: 100,\n          # Repeat substitutions to correctly handle overlapping matches.\n          # (repeated substitution will stop as soon as text stops changing)\n        }\n      ]\n    ],\n    [\n      sigils: [:SQL],  #  <───────── [7] Try substitution within sigils.\n      replacements: [\n        {\n          ~r/(~u[\"][^\"]+[^\"\\s])\\s+\"/s,\n          ~S'\\1\"'\n        }\n      ]\n    ],\n    [                               #  ┌──── [8] Try handy substitution presets.\n      extensions: [\".ex\", \".exs\"],  #  │\n      preset_trim_sigil_whitespace: [:u],\n      preset_collapse_sigil_whitespace: [:u, :SQL],\n      preset_do_on_separate_line_after_multiline_signature: true\n    ]\n  ]\n]\n```","ref":"RegexFormatter.html"},{"type":"extras","title":"Regex Formatter","doc":"# Regex Formatter\n\nDon't fear the regex. Malleable `mix format` via powerful code-search/replace.","ref":"readme.html"},{"type":"extras","title":"Installation - Regex Formatter","doc":"Add `regex_formatter` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:regex_formatter, \"~> 0.1.0\"}\n  ]\nend\n```\nthen\n```\nmix deps.get\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Regex Formatter","doc":"Configure and run Regex Formatter in three steps:\n\n1. Add `RegexFormatter` to `plugins` list in `.formatter.exs`.\n2. Add `regex_formatter` config to `.formatter.exs` following examples below.\n3. Run `mix format` — Regex Formatter rules will run after normal format operations.\n\n```elixir\n[                                        #  ┌── [1] Add RegexFormatter to plugins.\n  ...                                    #  │\n  plugins: [Phoenix.LiveView.HTMLFormatter, RegexFormatter],\n  regex_formatter: [  #  <───────────────────── [2] Add configuration for RegexFormatter.\n    [\n      extensions: [\".ex\", \".exs\"],  #  <─────── [3] Configure file types to replace on.\n      replacements: [\n        {\n          ~r/~u[\"]\\s+/s,  #  <───────────────── [4] Define search pattern.\n          \"~u\\\"\"          #  <───────────────── [5] Define replacement pattern.\n        },\n        {\n          ~r/(~u[\"][^\"]+[^\"\\s])  +([^\"\\s])/s,\n          ~S'\\1 \\2',   #  <──────────────────── [6] Replace with matched groups.\n          repeat: 100,\n          # Repeat substitutions to correctly handle overlapping matches.\n          # (repeated substitution will stop as soon as text stops changing)\n        },\n      ]\n    ],\n    [\n      sigils: [:sql],  #  <──────────────────── [7] Try substitution within sigils.\n      replacements: [\n        {\n          ~r/(~u[\"][^\"]+[^\"\\s])\\s+\"/s,\n          ~S'\\1\"'\n        },\n      ]\n    ],\n    [                               #  ┌─────── [8] Try handy substitution presets.\n      extensions: [\".ex\", \".exs\"],  #  │\n      preset_trim_sigil_whitespace: [:u],\n      preset_collapse_sigil_whitespace: [:u, :SQL],\n      preset_do_on_separate_line_after_multiline_signature: true\n    ]\n  ]\n]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Prior Art - Regex Formatter","doc":"Inspired by the incredibly cool https://github.com/frerich/filter_formatter, which\nalso helped provide excellent initial guidance for setting up a `mix format` plugin.","ref":"readme.html#prior-art"},{"type":"extras","title":"License - Regex Formatter","doc":"MIT","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}